<?php

namespace Schaffen\Financial\BillingRoute\Models;

use Illuminate\Database\Eloquent\Model;
use Schaffen\Core\Person\Models\Person;

class Route extends Model
{
    protected $table = "movimentacao.rota";
    protected $primaryKey = "rot_codigo";
    protected $fillable = ["rot_descricao"];
    const CREATED_AT = "rot_date_insert";
    const CREATED_BY = "rot_user_insert";
    const UPDATED_AT = "rot_date_update";
    const UPDATED_BY = "rot_user_update";

    //rota clientes
    public function client_route()
    {
        return $this->hasMany(ClientRoute::class, "roc_fk_rot_codigo");
    }

    //rota vendedores
    public function salesman_route()
    {
        return $this->hasMany(SalesmanRoute::class, "rov_fk_rot_codigo");
    }

    //clientes
    public function clients(){
        return $this->hasManyThrough(
            Person::class,
            ClientRoute::class,
            'roc_fk_rot_codigo',
            'pes_codigo',
            'rot_codigo',
            'roc_fk_pes_codigo'
        )->with('address');
    }

    //vendedores
    public function salesman(){
        return $this->hasManyThrough(
            Person::class,
            SalesmanRoute::class,
            'rov_fk_rot_codigo',
            'pes_codigo',
            'rot_codigo',
            'rov_fk_pes_codigo'
        );
    }
}